unit TPicFile;
(*
                 TPicFile Component (Object Pascal - Delphi 2.0)
                           (c) Daniel Doubrovkine
  Stolen Technologies Inc. - University of Geneva - 1996 - All Rights Reserved
                       for XReplace-32, version 1.51

             This source code is free for educational purposes only.
             If you intend to use this code in an application other
             than freeware, please contact the author for agreement.

                   e-mail welcome: dblock@infomaniak.ch
                        no warranty of any kind

                   this unit is useless under NT 3.5x
*)

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, FileCtrl, ShellApi;

type
  TPicFileListBox = class(TFileListBox)
  private
     NT351: boolean;                           {NT 3.5x does not support ExtractAssociatedIcon}
     constructor Create(AOwner: TComponent);  override;
     procedure DrawItem(Index: Integer; Rect: TRect; State: TOwnerDrawState); override;
     end;

procedure Register;

implementation

procedure Register;
begin
   RegisterComponents('Samples', [TPicFileListBox]);
   end;

function IsNt351:boolean;
var
   VersionInfo: TOsVersionInfo;
begin
   VersionInfo.dwOsVersionInfoSize:=sizeof(TOsVersionInfo);
   if (GetVersionEx(VersionInfo)=false) then begin
      Result:=True;
      exit;
      end;
  if (VersionInfo.dwMajorVersion=3) and  {NT 3.x}
     (VersionInfo.dwPlatformId=2) and    {Windows NT}
     ((VersionInfo.dwMinorVersion=51) or {3.5 or 3.51}
     (VersionInfo.dwMinorVersion=50)) then Result:=True else Result:=False;
   end;

constructor TPicFileListBox.Create(AOwner: TComponent);
begin
   inherited Create(AOwner);
   Nt351:=IsNt351;
   end;

procedure TPicFileListBox.DrawItem(Index: Integer; Rect: TRect; State: TOwnerDrawState);
var
  offset: Integer;
  IconIndex: word;
  dc: hdc;
  Icon: hIcon;
  LDirectory: string;
begin
  try
  if Nt351 then inherited else
  with Canvas do
  begin
    FillRect(Rect);
    offset := 2;
    if ShowGlyphs then
    begin
      LDirectory:=Directory;              {avoid double \\ and a GPF}
      if LDirectory[Length(LDirectory)]='\' then Delete(LDirectory, Length(LDirectory),1);
      Icon:=ExtractAssociatedIcon(Application.Handle,PChar(LDirectory+'\'+Items[Index]),IconIndex);
      if (Icon <> 0) then begin
         dc:=GetDc(Self.Handle);
         DrawIconEx(dc,
                    Rect.Left+2,
                    Rect.Top,
                    Icon,
                    Rect.Bottom-Rect.Top-2,
                    Rect.Bottom-Rect.Top-2,
                    0,
                    Brush.Handle,
                    DI_NORMAL);
         end;
      offset:=Rect.bottom-Rect.top+3;
    end;
    TextOut(Rect.Left + offset, Rect.Top, Items[Index]) {output the text}
  end;
  except
  end;
end;

end.
